//Private
//var CadetTextRun = require("./CadetTextRunNode.js");
//var CadetStyle = require("./CadetStyleNode.js");
//var _intime=0;
//var _outtime=0;
//var _textRuns=[];


//Public
module.exports = CadetEvent;

function CadetEvent(i,o,a,va) {
	var CadetTextRun = require("./CadetTextRunNode.js");
	var CadetStyle = require("./CadetStyleNode.js");
    this.intime = i;
    this.outtime = o;
    this.align = 2;//center
    this.valign = 2;//bottom
    if( a ) this.align = a;
    if( va ) this.valign = va;
    this.textRuns = [];
    //console.log("CadetEvent: Module Contructed: with in=["+_intime+"] out=["+_outtime+"]");
    this.getRuns = getRuns;
	this.getLines = function(){
		var lines = [];
		var ev = this;
		//for each line in the event
		var runs = this.getRuns(); //this.textRuns;
		line = "";
		for( var j=0; j<runs.length; j++){
			var r = runs[j];
			if( r.linebreak || (j == runs.length-1) ){  //linebreak or the last of the runs...
			if(j == runs.length-1) line += r.text;//haven't accumulated it yet
			
			//add line to array !!! IF IT'S NOT BLANK
			if( line.trim().length > 0 ){
				lines.push(line.trim());
			}
			line = "";//reset the line accumulator
			} else {
				//keep accumulating line
				line += r.text;
			}
		} //for each run
		return lines;
	};
	this.setVAlign = setVAlign;
}

function setVAlign(n){
	this.valign = n;
}//setVAlign

function getRuns(){
	return this.textRuns;
}//getRuns

CadetEvent.prototype.getIntime = function(){
	return(this.intime);
}
CadetEvent.prototype.getOuttime = function(){
	return(this.outtime);
}
CadetEvent.prototype.setIntime = function(n){
	this.intime = n;
}
CadetEvent.prototype.setOuttime = function(n){
	this.outtime = n;
}

CadetEvent.prototype.getText = function(){
	var sfoo="";
	for(var i=0; i<this.textRuns.length; i++){
		sfoo += this.textRuns[i].getText();
	}
	return sfoo;
}

CadetEvent.prototype.addRun = function(r, newline){
	if( newline ){ //first add a newline run, then the text run
		var newlineStyle = new CadetStyle(false, false, false, "white", "black", true);
		var newlineRun = new CadetTextRun(newlineStyle, "");
		this.textRuns.push(newlineRun);
		this.textRuns.push(r);
	} else {	//the first text run, just add it
		this.textRuns.push(r);
	}
    //console.log("CadetEvent:addRun: with r=["+r.toString()+"]");
}

CadetEvent.prototype.addFullRun = function(r){
	this.textRuns.push(r);
    //console.log("CadetEvent:addFullRun: with r=["+r.toString()+"]");
}

CadetEvent.prototype.getRun = function(i){
    //console.log("CadetEvent:getRun("+i+"): =["+_textRuns[i].toString()+"]");
}

CadetEvent.prototype.toString = function() {
	//console.log("CadetEvent:toString hello world");
	//console.log("in=["+_intime+"] out=["+_outtime+"]");
	
	var sfoo="CadetEvent: ";
	//sfoo += " linebreak:"+_linebreak;
	sfoo += "intime:"+this.intime;
	sfoo += ", outtime:"+this.outtime;
	sfoo += ", align:"+this.align;
	sfoo += ", valign:"+this.valign;
	sfoo += ", runsCount:"+this.textRuns.length;
	return(sfoo.trim());
};
CadetEvent.prototype.printTimes = function() {
	console.log("CadetEvent: in=["+this.intime+"] out=["+this.outtime+"]");
};

CadetEvent.prototype.getLines = function(){
	var lines = [];
	var ev = this;
	//for each line in the event
	var runs = this.getRuns();
	line = "";
	for( var j=0; j<runs.length; j++){
		var r = runs[j];
		if( r.linebreak || (j == runs.length-1) ){  //linebreak or the last of the runs...
			if(j == runs.length-1) line += r.text;//haven't accumulated it yet
			
			//add line to array !!! IF IT'S NOT BLANK
			if( line.trim().length > 0 ){
				lines.push(line.trim());
			}
			line = "";//reset the line accumulator
		} else {
			//keep accumulating line
			line += r.text;
		}
	} //for each run
	console.log("CadetEvent: getLines(): lines.length=["+lines.length+"]");
	return lines;
};

